/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package com.unis.basic.info.modular.orgInfo.service;

import com.baomidou.dynamic.datasource.annotation.DS;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.unis.basic.info.modular.orgInfo.entity.OrgInfo;
import com.unis.basic.info.modular.orgInfo.param.OrgInfoPageParam;
import com.unis.basic.info.modular.orgInfo.param.OrgInfoAddParam;
import com.unis.basic.info.modular.orgInfo.param.OrgInfoEditParam;
import com.unis.basic.info.modular.orgInfo.param.OrgInfoIdParam;
import com.unis.common.constant.DBConstant;
import com.unis.reserveLayout.modular.dataSystemInfo.param.DataPageParam;


import java.util.List;
import java.util.Map;

/**
 * 组织机构信息表Service接口
 *
 * @author shine
 * @date  2024/04/28 11:47
 **/
@DS(DBConstant.DS_DEPOT)
public interface OrgInfoService extends IService<OrgInfo> {

    /**
     * 获取组织机构信息表分页
     *
     * @author shine
     * @date  2024/04/28 11:47
     */
    Page<OrgInfo> page(OrgInfoPageParam orgInfoPageParam);

    /**
     * 添加组织机构信息表
     *
     * @author shine
     * @date  2024/04/28 11:47
     */
    void add(OrgInfoAddParam orgInfoAddParam);

    /**
     * 编辑组织机构信息表
     *
     * @author shine
     * @date  2024/04/28 11:47
     */
    void edit(OrgInfoEditParam orgInfoEditParam);

    /**
     * 删除组织机构信息表
     *
     * @author shine
     * @date  2024/04/28 11:47
     */
    void delete(List<OrgInfoIdParam> orgInfoIdParamList);

    /**
     * 获取组织机构信息表详情
     *
     * @author shine
     * @date  2024/04/28 11:47
     */
    OrgInfo detail(OrgInfoIdParam orgInfoIdParam);

    /**
     * 获取组织机构信息表详情
     *
     * @author shine
     * @date  2024/04/28 11:47
     **/
    OrgInfo queryEntity(Integer id);

    IPage<Map<String,Object>> findPage(OrgInfoPageParam orgInfoPageParam);

    List<OrgInfo> getAllList();

    Integer selectOrgInfoCount();

    IPage<Map<String,Object>> selectStoreHousePage(OrgInfoPageParam orgInfoPageParam);

    Integer selectStoreHouseCount();

    Integer selectInventoryCount();

    List<Map<String, Object>> selectGrainNatureName(DataPageParam dataPageParam);

    IPage<Map<String,Object>> selectKcCountPage(DataPageParam dataPageParam);

    List<Map<String,Object>> selectKcChart(DataPageParam dataPageParam);

    List<Map<String,Object>> selectKcGrainNatureChart(DataPageParam dataPageParam);

    Map<String,Object> selectKcSumRepot(DataPageParam dataPageParam);

    List<Map<String,Object>> selectKcGrainGradeRepot(DataPageParam dataPageParam);

    List<Map<String,Object>> selectKcGrainNatureRepot(DataPageParam dataPageParam);

    List<Map<String,Object>> selectKcYearRepot(DataPageParam dataPageParam);

    Map<String,Object> selectByOrgInfo(DataPageParam dataPageParam);
}
